Opened 8 years ago

Closed 8 years ago

#207 closed enhancement (fixed)

predicted time of extended self-test appears to be capped at 255 minutes

Reported by: rekt Owned by: Christian Franke
Priority: minor Milestone: Release 5.43
Component: smartctl Version: 5.39.1
Keywords: ata Cc:

Description

Both of these disks report taking 255 minutes to complete the long (extended) self-test:

0 root@monkey:~# smartctl -t long /dev/sdd
smartctl 5.40 2010-07-12 r3124 [x86_64-unknown-linux-gnu] (local build)
Copyright (C) 2002-10 by Bruce Allen, http://smartmontools.sourceforge.net

=== START OF OFFLINE IMMEDIATE AND SELF-TEST SECTION ===
Sending command: "Execute SMART Extended self-test routine immediately in off-line mode".
Drive command "Execute SMART Extended self-test routine immediately in off-line mode" successful.
Testing has begun.
Please wait 255 minutes for test to complete.
Test will complete after Tue Nov 22 04:31:37 2011

Use smartctl -X to abort test.
0 root@monkey:~# smartctl -t long /dev/sdb
smartctl 5.40 2010-07-12 r3124 [x86_64-unknown-linux-gnu] (local build)
Copyright (C) 2002-10 by Bruce Allen, http://smartmontools.sourceforge.net

=== START OF OFFLINE IMMEDIATE AND SELF-TEST SECTION ===
Sending command: "Execute SMART Extended self-test routine immediately in off-line mode".
Drive command "Execute SMART Extended self-test routine immediately in off-line mode" successful.
Testing has begun.
Please wait 255 minutes for test to complete.
Test will complete after Tue Nov 22 04:31:41 2011
0 root@monkey:~# 

However, their internal firmware believes that the amount of time taken varies significantly (686 and 506 minutes respectively, if i'm reading this output correctly):

0 root@monkey:~# smartctl -a /dev/sdb | egrep -A1 'START OF INFO|Total time'
=== START OF INFORMATION SECTION ===
Device Model:     WDC WD2003FYYS-02W0B0
--
Total time to complete Offline 
data collection:                 (30360) seconds.
0 root@monkey:~# smartctl -a /dev/sdd | egrep -A1 'START|Total\ time'
=== START OF INFORMATION SECTION ===
Device Model:     WDC WD2002FYPS-02W3B0
--
Total time to complete Offline 
data collection:                 (41160) seconds.
0 root@monkey:~# 

This makes me think that the report of 255 minutes is flawed (maybe capped by an unsigned char or something?)

This is using stock debian squeeze:

0 root@monkey:~# uname -a
Linux monkey 2.6.32-5-vserver-amd64 #1 SMP Mon Oct 3 06:23:01 UTC 2011 x86_64 GNU/Linux
0 root@monkey:~# smartctl --version
smartctl 5.40 2010-07-12 r3124 [x86_64-unknown-linux-gnu] (local build)
Copyright (C) 2002-10 by Bruce Allen, http://smartmontools.sourceforge.net

smartctl comes with ABSOLUTELY NO WARRANTY. This is free
software, and you are welcome to redistribute it under
the terms of the GNU General Public License Version 2.
See http://www.gnu.org for further details.

smartmontools release 5.40 dated 2009-12-09 at 21:00:32 UTC
smartmontools SVN rev 3124 dated 2010-07-12 at 19:21:00
smartmontools build host: x86_64-unknown-linux-gnu
smartmontools build configured: 2010-12-26 11:52:46 UTC
smartctl compile dated Dec 26 2010 at 11:53:03
smartmontools configure arguments:  '--prefix=/usr' '--sysconfdir=/etc' '--mandir=/usr/share/man' '--with-initscriptdir=/etc/init.d' '--with-docdir=/usr/share/doc/smartmontools' '--enable-drivedb' '--enable-savestates' '--enable-attributelog' '--with-savestates=/var/lib/smartmontools/smartd.' '--with-attributelog=/var/lib/smartmontools/attrlog.' '--with-selinux' 'CXXFLAGS=-g -O2' 'LDFLAGS=' 'CPPFLAGS=' 'CFLAGS=-g -O2 -fsigned-char -Wall -O2'
0 root@monkey:~# 

Change History (2)

comment:1 Changed 8 years ago by Christian Franke

Component: allsmartctl
Keywords: ata added
Milestone: Release 5.43
Owner: changed from somebody to Christian Franke
Status: newaccepted
Type: defectenhancement

The "Extended self-test routine recommended polling time" is in byte 373 of SMART data block. Recently ATA ACS adds bytes 375-376 which should be used if byte 373 is 255. This is not implemented yet.

comment:2 Changed 8 years ago by Christian Franke

Resolution: fixed
Status: acceptedclosed
Note: See TracTickets for help on using tickets.